# Compte rendu du TP Filtre audio

## Diagramme de la FSM

![Diagramme de la FSM](./img/FSM.drawio.png)


## Questions

### Question filtre 1 : Combien de processus sont utilisés et de quelles natures sont-ils ? Comment les différenciez-vous ?
Nous avons 2 processus, l'un pour définir les changements d'états après le début, et l'autre pour définir l'état initial. La différence entre eux réside dans les états que chacun définit : l'un concerne le premier état, tandis que l'autre concerne tous les autres états.


### Question filtre 2 : La simulation vous permet-elle de valider votre description VHDL ? Justifiez.
![Test de l'unité de controle](./img/controlUnitTest1.png)
![Test de l'unité de controle2](./img/controlUnitTest2.png)
Oui, comme il est possible de vérifier avec l'image, la simulation nous a permis de valider notre transcription VHDL. Avant chaque nouvel état, la condition est remplie pour permettre le changement. Nous avons constaté que cela est fait pour tous les états. Ainsi, la transcription est conforme au diagramme, et les sorties représentées suivent la séquence attendue.

### Question filtre 3 : Validez-vous la conception de l’unité de contrôle ?
Oui, nous avons validé la conception de l’unité de contrôle. Après avoir mis une chanson sur YouTube, avec des casques audio connectés à la protoboard, nous avons pu écouter la musique, même si la qualité n’était pas la meilleure parce qu’il y avait beaucoup de bruit. De plus, en activant ou non les interrupteurs, il y avait quelques modifications, comme le volume, le niveau de bruit etc.

### Question filtre 4 : Combien de processus sont utilisés et de quelles natures sont-ils ?
Quatre processus sont utilisés, et ils sont tous de nature séquentielle.

### Question filtre 5 : La simulation vous permet-elle de valider votre description VHDL ? Sinon, quel élément pose problème ? Comment pouvez-vous le corriger ? Justifiez
La simulation nous a d'abord permis de constater que l'unité opérative générait une séquence incorrecte par rapport à la séquence attendue. Cependant, nous avons identifié que le problème venait uniquement de l'absence d'arrondi des valeurs en fonction du premier chiffre décimal. En appliquant cet ajustement, la séquence est devenue conforme aux attentes.

### Question filtre 6 : Validez-vous la conception de l’unité opérative ? Sinon, quel élément pose problème ? Comment pouvez-vous le corriger ?
Oui, nous validons la conception de l’unité opérative. Nous l’avons testée sur la carte FPGA en faisant jouer une musique sur YouTube, et nous avons obtenu des résultats conformes aux attentes.